/* tslint:disable */
/* eslint-disable */
/**
 * Guichet API
 * Programmatic API for managing a user account in Deuxfleurs\' Guichet.  *Disclaimer: this API is currently unstable and does not yet cover all the features availble from Guichet\'s web interface.* 
 *
 * The version of the OpenAPI document: v0.1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import * as runtime from '../runtime';
import type {
  ConfigureWebsiteRequest,
  ListWebsites200Response,
  WebsiteInfo,
} from '../models/index';
import {
    ConfigureWebsiteRequestFromJSON,
    ConfigureWebsiteRequestToJSON,
    ListWebsites200ResponseFromJSON,
    ListWebsites200ResponseToJSON,
    WebsiteInfoFromJSON,
    WebsiteInfoToJSON,
} from '../models/index';

export interface ConfigureWebsiteOperationRequest {
    vhost: string;
    configureWebsiteRequest: ConfigureWebsiteRequest;
}

export interface CreateWebsiteRequest {
    vhost: string;
}

export interface DeleteWebsiteRequest {
    vhost: string;
}

export interface GetWebsiteRequest {
    vhost: string;
}

/**
 * 
 */
export class WebsiteApi extends runtime.BaseAPI {

    /**
     * Modifies configuration of the website with identifier `vhost`. 
     * Configure website
     */
    async configureWebsiteRaw(requestParameters: ConfigureWebsiteOperationRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<WebsiteInfo>> {
        if (requestParameters['vhost'] == null) {
            throw new runtime.RequiredError(
                'vhost',
                'Required parameter "vhost" was null or undefined when calling configureWebsite().'
            );
        }

        if (requestParameters['configureWebsiteRequest'] == null) {
            throw new runtime.RequiredError(
                'configureWebsiteRequest',
                'Required parameter "configureWebsiteRequest" was null or undefined when calling configureWebsite().'
            );
        }

        const queryParameters: any = {};

        const headerParameters: runtime.HTTPHeaders = {};

        headerParameters['Content-Type'] = 'application/json';

        if (this.configuration && (this.configuration.username !== undefined || this.configuration.password !== undefined)) {
            headerParameters["Authorization"] = "Basic " + btoa(this.configuration.username + ":" + this.configuration.password);
        }
        const response = await this.request({
            path: `/website/{vhost}`.replace(`{${"vhost"}}`, encodeURIComponent(String(requestParameters['vhost']))),
            method: 'PATCH',
            headers: headerParameters,
            query: queryParameters,
            body: ConfigureWebsiteRequestToJSON(requestParameters['configureWebsiteRequest']),
        }, initOverrides);

        return new runtime.JSONApiResponse(response, (jsonValue) => WebsiteInfoFromJSON(jsonValue));
    }

    /**
     * Modifies configuration of the website with identifier `vhost`. 
     * Configure website
     */
    async configureWebsite(requestParameters: ConfigureWebsiteOperationRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<WebsiteInfo> {
        const response = await this.configureWebsiteRaw(requestParameters, initOverrides);
        return await response.value();
    }

    /**
     * Creates a new website with identifier `vhost`. 
     * Create a new website
     */
    async createWebsiteRaw(requestParameters: CreateWebsiteRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<WebsiteInfo>> {
        if (requestParameters['vhost'] == null) {
            throw new runtime.RequiredError(
                'vhost',
                'Required parameter "vhost" was null or undefined when calling createWebsite().'
            );
        }

        const queryParameters: any = {};

        const headerParameters: runtime.HTTPHeaders = {};

        if (this.configuration && (this.configuration.username !== undefined || this.configuration.password !== undefined)) {
            headerParameters["Authorization"] = "Basic " + btoa(this.configuration.username + ":" + this.configuration.password);
        }
        const response = await this.request({
            path: `/website/{vhost}`.replace(`{${"vhost"}}`, encodeURIComponent(String(requestParameters['vhost']))),
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
        }, initOverrides);

        return new runtime.JSONApiResponse(response, (jsonValue) => WebsiteInfoFromJSON(jsonValue));
    }

    /**
     * Creates a new website with identifier `vhost`. 
     * Create a new website
     */
    async createWebsite(requestParameters: CreateWebsiteRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<WebsiteInfo> {
        const response = await this.createWebsiteRaw(requestParameters, initOverrides);
        return await response.value();
    }

    /**
     * Delete the website with identifier `vhost`. 
     * Delete Website
     */
    async deleteWebsiteRaw(requestParameters: DeleteWebsiteRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<void>> {
        if (requestParameters['vhost'] == null) {
            throw new runtime.RequiredError(
                'vhost',
                'Required parameter "vhost" was null or undefined when calling deleteWebsite().'
            );
        }

        const queryParameters: any = {};

        const headerParameters: runtime.HTTPHeaders = {};

        if (this.configuration && (this.configuration.username !== undefined || this.configuration.password !== undefined)) {
            headerParameters["Authorization"] = "Basic " + btoa(this.configuration.username + ":" + this.configuration.password);
        }
        const response = await this.request({
            path: `/website/{vhost}`.replace(`{${"vhost"}}`, encodeURIComponent(String(requestParameters['vhost']))),
            method: 'DELETE',
            headers: headerParameters,
            query: queryParameters,
        }, initOverrides);

        return new runtime.VoidApiResponse(response);
    }

    /**
     * Delete the website with identifier `vhost`. 
     * Delete Website
     */
    async deleteWebsite(requestParameters: DeleteWebsiteRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<void> {
        await this.deleteWebsiteRaw(requestParameters, initOverrides);
    }

    /**
     * Gets the configuration and status for the website `vhost`. This includes information about domains, bucket access keys, and quotas.  `quota_size` is given in bytes. `quota_files` indicates a number of files. 
     * Details on a website
     */
    async getWebsiteRaw(requestParameters: GetWebsiteRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<WebsiteInfo>> {
        if (requestParameters['vhost'] == null) {
            throw new runtime.RequiredError(
                'vhost',
                'Required parameter "vhost" was null or undefined when calling getWebsite().'
            );
        }

        const queryParameters: any = {};

        const headerParameters: runtime.HTTPHeaders = {};

        if (this.configuration && (this.configuration.username !== undefined || this.configuration.password !== undefined)) {
            headerParameters["Authorization"] = "Basic " + btoa(this.configuration.username + ":" + this.configuration.password);
        }
        const response = await this.request({
            path: `/website/{vhost}`.replace(`{${"vhost"}}`, encodeURIComponent(String(requestParameters['vhost']))),
            method: 'GET',
            headers: headerParameters,
            query: queryParameters,
        }, initOverrides);

        return new runtime.JSONApiResponse(response, (jsonValue) => WebsiteInfoFromJSON(jsonValue));
    }

    /**
     * Gets the configuration and status for the website `vhost`. This includes information about domains, bucket access keys, and quotas.  `quota_size` is given in bytes. `quota_files` indicates a number of files. 
     * Details on a website
     */
    async getWebsite(requestParameters: GetWebsiteRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<WebsiteInfo> {
        const response = await this.getWebsiteRaw(requestParameters, initOverrides);
        return await response.value();
    }

    /**
     * List all the user\'s websites 
     * List all websites
     */
    async listWebsitesRaw(initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<ListWebsites200Response>> {
        const queryParameters: any = {};

        const headerParameters: runtime.HTTPHeaders = {};

        if (this.configuration && (this.configuration.username !== undefined || this.configuration.password !== undefined)) {
            headerParameters["Authorization"] = "Basic " + btoa(this.configuration.username + ":" + this.configuration.password);
        }
        const response = await this.request({
            path: `/website`,
            method: 'GET',
            headers: headerParameters,
            query: queryParameters,
        }, initOverrides);

        return new runtime.JSONApiResponse(response, (jsonValue) => ListWebsites200ResponseFromJSON(jsonValue));
    }

    /**
     * List all the user\'s websites 
     * List all websites
     */
    async listWebsites(initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<ListWebsites200Response> {
        const response = await this.listWebsitesRaw(initOverrides);
        return await response.value();
    }

}
